    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56
    57  import  org.apache.bcel.Constants;
    58  import  java.io.*;
    59
    60  /***
    61   * This class represents a (PC offset, line number) pair, i.e., a line number in
    62   * the source that corresponds to a relative address in the byte code. This
    63   * is used for debugging purposes.
    64   *
    65   * @version $Id: LineNumber.java,v 1.3 2002/07/11 19:39:04 mdahm Exp $
    66   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    67   * @see     LineNumberTable
    68   */
    69  public final class LineNumber implements Cloneable, Node, Serializable {
    70    private int start_pc;    // Program Counter (PC) corresponds to line
    71    private int line_number; // number in source file
    72
    73    /***
    74     * Initialize from another object.
    75     */
    76    public LineNumber(LineNumber c) {
    77      this(c.getStartPC(), c.getLineNumber());
    78    }
    79
    80    /***
    81     * Construct object from file stream.
    82     * @param file Input stream
    83     * @throws IOException
    84     */
    85    LineNumber(DataInputStream file) throws IOException
    86    {
    87      this(file.readUnsignedShort(), file.readUnsignedShort());
    88    }
    89
    90    /***
    91     * @param start_pc Program Counter (PC) corresponds to
    92     * @param line_number line number in source file
    93     */
    94    public LineNumber(int start_pc, int line_number)
    95    {
    96      this.start_pc    = start_pc;
    97      this.line_number = line_number;
    98    }
    99
    100   /***
    101    * Called by objects that are traversing the nodes of the tree implicitely
    102    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    103    * fields, attributes, etc. spawns a tree of objects.
    104    *
    105    * @param v Visitor object
    106    */
    107   public void accept(Visitor v) {
    108     v.visitLineNumber(this);
    109   }
    110
    111   /***
    112    * Dump line number/pc pair to file stream in binary format.
    113    *
    114    * @param file Output file stream
    115    * @throws IOException
    116    */
    117   public final void dump(DataOutputStream file) throws IOException
    118   {
    119     file.writeShort(start_pc);
    120     file.writeShort(line_number);
    121
    122   }
    123   /***
    124    * @return Corresponding source line
    125    */
    126   public final int getLineNumber() { return line_number; }
    127
    128   /***
    129    * @return PC in code
    130    */
    131   public final int getStartPC() { return start_pc; }
    132
    133   /***
    134    * @param line_number.
    135    */
    136   public final void setLineNumber(int line_number) {
    137     this.line_number = line_number;
    138   }
    139
    140   /***
    141    * @param start_pc.
    142    */
    143   public final void setStartPC(int start_pc) {
    144     this.start_pc = start_pc;
    145   }
    146
    147   /***
    148    * @return String representation
    149    */
    150   public final String toString() {
    151     return "LineNumber(" + start_pc + ", " + line_number + ")";
    152   }
    153
    154   /***
    155    * @return deep copy of this object
    156    */
    157   public LineNumber copy() {
    158     try {
    159       return (LineNumber)clone();
    160     } catch(CloneNotSupportedException e) {}
    161
    162     return null;
    163   }
    164 }

This page was automatically generated by Maven